﻿using MusicManager.View;
using MusicManager.ViewModel.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace MusicManager.App.Services
{
    public class DialogWindowService : IDialogWindowService
    {
        private PWindow _currentPWindow;



        public bool ShowModalDialog(string windowname, object datacontext, object owner, bool topMost = false, bool showInTaskbar = true)
        {
            PWindow Pwin = new PWindow(windowname, datacontext, SizeToContent.WidthAndHeight, WindowStartupLocation.CenterOwner);
            _currentPWindow = Pwin;

            Pwin.Topmost = topMost;
            Pwin.ShowInTaskbar = showInTaskbar;
            Pwin.Owner = Pwin.FindOwnerWindow(owner);
            Pwin.AsPModalDialog = true;

            return Convert.ToBoolean(Application.Current.Dispatcher.Invoke(() => Pwin.ShowDialog()));
        }

        public void CloseDialog()
        {
            if (_currentPWindow != null)
                _currentPWindow.Close();
        }

        public void CloseDialog(object vm)
        {
            Window owner = Application.Current.Windows.Cast<Window>().SingleOrDefault(x => x.DataContext != null && x.DataContext.GetType() == vm.GetType());

            if (owner == null)
            {
                IEnumerable<Window> allWindows = from win in Application.Current.Windows.Cast<Window>().ToList() select win;
                foreach (Window window in allWindows)
                {
                    if (window.DataContext.GetType() == vm.GetType()) window.Close();
                }
            }
            else
                owner.Close();
        }
    }

}
