﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using MusicManager.View;
using MusicManager.ViewModel.Services;

namespace MusicManager.App.Services
{
    public class WindowService : IWindowService
    {
        private PWindow _win;

        public bool OpenWindow(string windowname, object datacontext, object owner, bool topMost = false, bool showInTaskbar = true)
        {
            PWindow Pwin = new PWindow(windowname, datacontext, SizeToContent.WidthAndHeight, WindowStartupLocation.CenterScreen)
            {
                Topmost = topMost,
                ShowInTaskbar = showInTaskbar
            };
            Pwin.Owner = Pwin.FindOwnerWindow(owner);
            Pwin.AsPModalDialog = false;

            Application.Current.Dispatcher.Invoke(() => Pwin.Show());
            _win = Pwin;
            return true;
        }



        public void CloseWindow(object vm)
        {
            Window owner = Application.Current.Windows.Cast<Window>().SingleOrDefault(x => x.DataContext == vm);
            if (owner == null)
                owner = Application.Current.Windows.Cast<Window>().SingleOrDefault(x => x.DataContext != null && x.DataContext.GetType() == vm.GetType());

            if (owner == null)
            {
             
                IEnumerable<Window> allWindows = from win in Application.Current.Windows.Cast<Window>().ToList() select win;
                foreach (Window window in allWindows)
                {
                    if (window.DataContext.GetType() == vm.GetType())
                        window.Close();
                }
            }
            else
                owner.Close();
        }

        public void CloseWindow()
        {
            if (_win != null)
                _win.Close();
            else
                throw new Exception("Win was nothing!!!");
        }
    }

}
